diff -uNrd ircd-hybrid-6.3.1.dist/src/m_kline.c ircd-hybrid-6.3.1/src/m_kline.c
--- ircd-hybrid-6.3.1.dist/src/m_kline.c	Fri Dec 14 21:42:04 2001
+++ ircd-hybrid-6.3.1/src/m_kline.c	Thu May  1 12:04:01 2003
@@ -36,6 +36,7 @@
 #include "s_conf.h"
 #include "s_log.h"
 #include "s_misc.h"
+#include "s_serv.h"
 #include "send.h"
 #include "struct.h"
 #include "hash.h"
@@ -49,8 +50,13 @@
 
 extern ConfigFileEntryType ConfigFileEntry; /* defined in ircd.c */
 
+/* XXX in m_unkline.c */
+extern int remove_tkline_match(char *host,char *user, unsigned long ip);
+
 /* Local function prototypes */
+#if 0
 static int isnumber(char *);    /* return 0 if not, else return number */
+#endif
 static char *cluster(char *);
 
 /*
@@ -59,10 +65,6 @@
  */
 aPendingLine *PendingLines = NULL;
 
-#ifdef SLAVE_SERVERS
-extern aConfItem *find_special_conf(char *,int); /* defined in s_conf.c */
-#endif
-
 /*
  * LockFile routines
  */
@@ -70,12 +72,17 @@
 static void DelPending(aPendingLine *);
 static int LockedFile(const char *);
 static void WritePendingLines(const char *);
-static void WriteKline(const char *, struct Client *, struct Client *,
+static void WriteKline(const char *, struct Client *,
                        const char *, const char *, const char *, 
                        const char *, const char *);
 static void WriteDline(const char *, struct Client *,
                        const char *, const char *,
 		       const char *, const char *);
+#ifdef XLINE_COMMAND
+static void WriteXline(const char *, aClient *,
+                       const char *, const char *,
+                       const char *);
+#endif
 
 /*
 AddPending()
@@ -201,14 +208,13 @@
     {
       WriteKline(filename,
 		 PendingLines->sptr,
-		 PendingLines->rcptr,
 		 PendingLines->user,
 		 PendingLines->host,
 		 PendingLines->reason,
 		 PendingLines->oper_reason,
 		 PendingLines->when);
     }
-    else
+    else if (PendingLines->type == DLINE_TYPE)
     {
       WriteDline(filename,
 		 PendingLines->sptr,
@@ -217,6 +223,16 @@
 		 PendingLines->oper_reason,
 		 PendingLines->when);
     }
+#ifdef XLINE_COMMAND
+    else
+    {
+      WriteXline(filename,
+                 PendingLines->sptr,
+                 PendingLines->host,
+                 PendingLines->reason,
+                 PendingLines->when);
+    }
+#endif
 
     /*
      * Delete the K/D line from the list after we write
@@ -226,6 +242,14 @@
     DelPending(PendingLines);
     PendingLines = ptmp;
   } /* while (PendingLines) */
+
+  /* There's a chance a rehash has been done prior to the pending lines
+   * being written out to the conf file.  They may have been removed from
+   * memory.  For this reason, we should rehash the confs to be sure we
+   * don't lose any klines.
+   */
+  rehash(&me, &me, 0);
+
 } /* WritePendingLines() */
 
 /*
@@ -234,7 +258,7 @@
  */
 
 static void
-WriteKline(const char *filename, struct Client *sptr, struct Client *rcptr,
+WriteKline(const char *filename, struct Client *sptr,
            const char *user, const char *host,
 	   const char *reason, const char *oper_reason,
            const char *when)
@@ -256,26 +280,9 @@
 
   fchmod(out, 0660);
 
-#ifdef SLAVE_SERVERS
-  if (IsServer(sptr))
-  {
-    if (rcptr != NULL)
+  if (oper_reason != NULL)
+    {
       ircsprintf(buffer,
-		 "#%s!%s@%s from %s K'd: %s@%s:%s\n",
-		 rcptr->name,
-		 rcptr->username,
-		 rcptr->host,
-		 sptr->name,
-		 user,
-		 host,
-		 reason);
-  }
-  else
-#endif /* SLAVE_SERVERS */
-  {
-    if (oper_reason != NULL)
-      {
-	ircsprintf(buffer,
 		   "#%s!%s@%s K'd: %s@%s:%s|%s\n",
 		   sptr->name,
 		   sptr->username,
@@ -284,10 +291,10 @@
 		   host,
 		   reason,
 		   oper_reason);
-      }
-    else
-      {
-	ircsprintf(buffer,
+    }
+  else
+    {
+      ircsprintf(buffer,
 		   "#%s!%s@%s K'd: %s@%s:%s\n",
 		   sptr->name,
 		   sptr->username,
@@ -295,9 +302,7 @@
 		   user,
 		   host,
 		   reason);
-      }
-
-  }
+    }
 
   if (safe_write(sptr, filename, out, buffer) == (-1))
     return;
@@ -423,88 +428,48 @@
   char tmpch;
   int nonwild;
 
-#ifdef SLAVE_SERVERS
-  char *slave_oper;
-  struct Client *rcptr=NULL;
-
-  if(IsServer(sptr))
-    {
-      if(parc < 2)      /* pick up actual oper who placed kline */
-        return 0;
-
-      slave_oper = parv[1];     /* make it look like normal local kline */
-
-      parc--;
-      parv++;
-
-      if ( parc < 2 )
-        return 0;
-
-      if ((rcptr = hash_find_client(slave_oper,NULL)))
-        {
-          if(!IsPerson(rcptr))
-            return 0;
-        }
-      else
-        return 0;
-
-      if(!find_special_conf(sptr->name,CONF_ULINE))
-        {
-          sendto_realops("Received unauthorized K-line from %s",sptr->name);
-          return 0;
-        }
-      else
-        {
-          sendto_realops("Received K-line from %s", sptr->name);
-        }
-
 #ifdef HUB
-      sendto_slaves(sptr,"KLINE",slave_oper,parc,parv);
-#endif
-
+  if (IsServer(cptr))
+    {
+      if(parc == 6)
+        sendto_match_cap_servs(NULL, sptr, CAP_KLN,
+              ":%s KLINE %s %s %s %s :%s",
+              parv[0], parv[1], parv[2], parv[3], parv[4], parv[5]);
+      return 0;
     }
-  else
 #endif
-    {
-      if (!MyClient(sptr) || !IsAnOper(sptr))
-        {
-          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-          return 0;
-        }
 
-      if(!IsSetOperK(sptr))
-        {
-          sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
-          return 0;
-        }
+  if (!MyClient(sptr) || !IsAnOper(sptr))
+    {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      return 0;
+    }
 
-      if ( parc < 2 )
-        {
-          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
-                     me.name, parv[0], "KLINE");
-          return 0;
-        }
+  if(!IsSetOperK(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
+      return 0;
+    }
 
-#ifdef SLAVE_SERVERS
-      sendto_slaves(NULL,"KLINE",sptr->name,parc,parv);
-#endif
+  if ( parc < 2 )
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "KLINE");
+      return 0;
     }
 
   argv = parv[1];
 
-  if( (temporary_kline_time = isnumber(argv)) )
+  if( (temporary_kline_time = oper_time(argv)) )
     {
       if(parc < 3)
         {
-#ifdef SLAVE_SERVERS
-          if(!IsServer(sptr))
-#endif    
-             sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
-                        me.name, parv[0], "KLINE");
+          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                     me.name, parv[0], "KLINE");
           return 0;
         }
-      if(temporary_kline_time > (24*60))
-        temporary_kline_time = (24*60); /* Max it at 24 hours */
+      if(temporary_kline_time > MAXTKTIME)
+        temporary_kline_time = MAXTKTIME; /* Max it at 24 hours */
       temporary_kline_time_seconds = (time_t)temporary_kline_time * (time_t)60;
         /* turn it into minutes */
       argv = parv[2];
@@ -528,6 +493,8 @@
 
       if (!*host)               /* duh. no host found, assume its '*' host */
         host = "*";
+      if (!*user)               /* The oper gave us a "@host" kline */
+        user = "*";
       strncpy_irc(tempuser, user, USERLEN + 1); /* allow for '*' in front */
       tempuser[USERLEN + 1] = '\0';
       strncpy_irc(temphost, host, HOSTLEN);
@@ -547,10 +514,7 @@
 
       if (IsServer(acptr))
         {
-#ifdef SLAVE_SERVERS
-          if(!IsServer(sptr))
-#endif
-            sendto_one(sptr,
+          sendto_one(sptr,
               ":%s NOTICE %s :Can't KLINE a server, use @'s where appropriate",
                        me.name, parv[0]);
           return 0;
@@ -558,10 +522,7 @@
 
       if(IsElined(acptr))
         {
-#ifdef SLAVE_SERVERS
-          if(!IsServer(sptr))
-#endif
-            sendto_one(sptr,
+          sendto_one(sptr,
                        ":%s NOTICE %s :%s is E-lined",me.name,parv[0],
                        acptr->name);
           return 0;
@@ -588,10 +549,7 @@
     {
       if(strchr(argv, ':'))
         {
-#ifdef SLAVE_SERVERS
-          if(!IsServer(sptr))
-#endif
-            sendto_one(sptr,
+          sendto_one(sptr,
                        ":%s NOTICE %s :Invalid character ':' in comment",
                        me.name, parv[0]);
           return 0;
@@ -599,10 +557,7 @@
 
       if(strchr(argv, '#'))
         {
-#ifdef SLAVE_SERVERS
-          if(!IsServer(sptr))
-#endif
-            sendto_one(sptr,
+          sendto_one(sptr,
                        ":%s NOTICE %s :Invalid character '#' in comment",
                        me.name, parv[0]);
           return 0;
@@ -618,19 +573,13 @@
 
   if(strchr(host, '#'))
     {
-#ifdef SLAVE_SERVERS
-      if(!IsServer(sptr))
-#endif
-        sendto_one(sptr, ":%s NOTICE %s :Invalid character '#' in hostname",
+      sendto_one(sptr, ":%s NOTICE %s :Invalid character '#' in hostname",
                    me.name, parv[0]);
       return 0;
     }
   if(strchr(user, '#'))
     { 
-#ifdef SLAVE_SERVERS
-      if(!IsServer(sptr))
-#endif  
-        sendto_one(sptr, ":%s NOTICE %s :Invalid character '#' in username",
+      sendto_one(sptr, ":%s NOTICE %s :Invalid character '#' in username",
                    me.name, parv[0]);
       return 0;
     }   
@@ -683,9 +632,6 @@
      * Not enough non-wild characters were found, assume
      * they are trying to kline *@*.
      */
-#ifdef SLAVE_SERVERS
-    if (!IsServer(sptr))
-#endif
       sendto_one(sptr,
         ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
         me.name,
@@ -729,22 +675,48 @@
       ip = 0L;
     }
 
-  if( (aconf = is_klined(host,user,(unsigned long)ip)) )
+  if( (aconf = is_tklined(host,user,(unsigned long)ip)) )
      {
-       char *nrkreason;
-
-       if( aconf->status & CONF_KILL )
-         {
-           nrkreason = aconf->passwd ? aconf->passwd : "<No Reason>";
-#ifdef SLAVE_SERVERS
-           if(!IsServer(sptr))
-#endif
+       /* This needs optimized */
+       if (temporary_kline_time == 0)
+       {
+         if(remove_tkline_match(host,user,(unsigned long)ip))
+           {
+             sendto_one(sptr,
+                        ":%s NOTICE %s :Temporary K-line [%s@%s] overridden",
+                         me.name, parv[0], user, host);
+           }
+         /* Should NOT get here... */
+       }
+       else
+       {
+         /* If it's temporary already, no need to override */
+         if( aconf->status & CONF_KILL )
+           {
+             char *nrkreason = aconf->passwd ? aconf->passwd : "<No Reason>";
              sendto_one(sptr,
                         ":%s NOTICE %s :[%s@%s] already K-lined by [%s@%s] - %s",
                         me.name,
                         parv[0],
                         user,host,
                         aconf->user,aconf->host,nrkreason);
+             return 0;
+           }
+       }
+     }
+  else if( (aconf = is_pklined(host,user,(unsigned long)ip)) )
+     {
+       char *nrkreason;
+
+       if( aconf->status & CONF_KILL )
+         {
+           nrkreason = aconf->passwd ? aconf->passwd : "<No Reason>";
+           sendto_one(sptr,
+                      ":%s NOTICE %s :[%s@%s] already K-lined by [%s@%s] - %s",
+                      me.name,
+                      parv[0],
+                      user,host,
+                      aconf->user,aconf->host,nrkreason);
            return 0;
          }
      }
@@ -788,7 +760,15 @@
       rehashed = YES;
       dline_in_progress = NO;
       nextping = CurrentTime;
-      sendto_realops("%s added temporary %d min. K-Line for [%s@%s] [%s]",
+      if (oper_reason != NULL)
+        sendto_realops("%s added temporary %d min. K-Line for [%s@%s] [%s|%s]",
+                     parv[0],
+                     temporary_kline_time,
+                     user,
+                     host,
+                     reason, oper_reason);
+      else
+        sendto_realops("%s added temporary %d min. K-Line for [%s@%s] [%s]",
 		     parv[0],
 		     temporary_kline_time,
 		     user,
@@ -812,15 +792,26 @@
   else
     add_mtrie_conf_entry(aconf,CONF_KILL);
 
-  sendto_realops("%s added K-Line for [%s@%s] [%s]",
-		 sptr->name,
-		 user,
-		 host,
-		 reason);
-
-
-  log(L_TRACE, "%s added K-Line for [%s@%s] [%s|%s]",
-      sptr->name, user, host, reason, oper_reason ? oper_reason : "");
+  if (oper_reason != NULL)
+  {
+    sendto_realops("%s added K-Line for [%s@%s] [%s|%s]",
+                 sptr->name,
+                 user,
+                 host,
+                 reason, oper_reason);
+    log(L_TRACE, "%s added K-Line for [%s@%s] [%s|%s]",
+        sptr->name, user, host, reason, oper_reason);
+  }
+  else
+  {
+    sendto_realops("%s added K-Line for [%s@%s] [%s]",
+                 sptr->name,
+                 user,
+                 host,
+                 reason);
+    log(L_TRACE, "%s added K-Line for [%s@%s] [%s]",
+        sptr->name, user, host, reason);
+  }
 
   kconf = get_conf_name(KLINE_TYPE);
 
@@ -845,12 +836,10 @@
     DupString(pptr->host, host);
     DupString(pptr->reason, reason);
     DupString(pptr->when, current_date);
-
-#ifdef SLAVE_SERVERS
-    pptr->rcptr = rcptr;
-#else
-    pptr->rcptr = NULL;
-#endif
+    if (oper_reason != NULL)
+      DupString(pptr->oper_reason, oper_reason);
+    else
+      pptr->oper_reason = NULL;  /* Yes this is needed */
 
     sendto_one(sptr,
       ":%s NOTICE %s :Added K-Line [%s@%s] (config file write delayed)",
@@ -875,25 +864,13 @@
   /*
    * Write kline to configuration file
    */
-#ifdef SLAVE_SERVERS
-  WriteKline(kconf,
-	     sptr,
-	     rcptr,
-	     user,
-	     host,
-	     reason,
-	     oper_reason,
-	     current_date);
-#else
   WriteKline(kconf,
 	     sptr,
-	     NULL,
 	     user,
 	     host,
 	     reason,
 	     oper_reason,
 	     current_date);
-#endif
 
   rehashed = YES;
   dline_in_progress = NO;
@@ -901,6 +878,7 @@
   return 0;
 } /* m_kline() */
 
+#if 0
 /*
  * isnumber()
  * 
@@ -933,6 +911,7 @@
     result = 1;
   return(result);
 }
+#endif
 
 /*
  * cluster()
@@ -1076,6 +1055,9 @@
   char buffer[1024];
   const char* current_date;
   const char *dconf;
+  char *argv;
+  int temp_dline_time = 0;
+  time_t temporary_dline_time_seconds=0;
 
   if (!MyClient(sptr) || !IsAnOper(sptr))
     {
@@ -1096,7 +1078,27 @@
       return 0;
     }
 
-  host = parv[1];
+  argv = parv[1];
+  
+  if((temp_dline_time = oper_time(argv)))
+  {
+      if(parc < 3)
+      {
+	  sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+		     me.name, parv[0], "DLINE");
+	  return 0;
+      }
+
+      /* maxed at 7 days */
+      if(temp_dline_time > (24*60*7))
+	  temp_dline_time = (24*60*7);
+
+      temporary_dline_time_seconds = (time_t)temp_dline_time * (time_t)60;
+      argv = parv[2];
+      parc--;
+  }
+  
+  host = argv;
   strncpy_irc(cidr_form_host, host, 32);
   cidr_form_host[32] = '\0';
 
@@ -1112,7 +1114,7 @@
 
   if(!is_address(host,&ip_host,&ip_mask))
     {
-      if (!(acptr = find_chasing(sptr, parv[1], NULL)))
+      if (!(acptr = find_chasing(sptr, argv, NULL)))
         return 0;
 
       if(!acptr->user)
@@ -1181,9 +1183,14 @@
     }
 
 
+  if(temp_dline_time)
+      argv = parv[3];
+  else
+      argv = parv[2];
+
   if (parc > 2) /* host :reason */
     {
-      if(strchr(parv[2], ':'))
+      if(strchr(argv, ':'))
         {
           sendto_one(sptr,
                      ":%s NOTICE %s :Invalid character ':' in comment",
@@ -1191,7 +1198,7 @@
           return 0;
         }
 
-      if(strchr(parv[2], '#'))
+      if(strchr(argv, '#'))
         {
           sendto_one(sptr,
                      ":%s NOTICE %s :Invalid character '#' in comment",
@@ -1199,8 +1206,8 @@
           return 0;
         }
 
-      if(*parv[2])
-        reason = parv[2];
+      if(*argv)
+        reason = argv;
       else
         reason = "No reason";
     }
@@ -1245,6 +1252,19 @@
        
      }
 
+  /* allow permanent dlines to overwrite temp dlines.. */
+  if((aconf = find_tdline(ip_host)) && temp_dline_time)
+  {
+      char *nrkreason;
+
+      nrkreason = aconf->passwd ? aconf->passwd : "<No Reason>";
+
+      sendto_one(sptr, ":%s NOTICE %s :[%s] already D-lined by [%s] - %s",
+		 me.name, parv[0], host, aconf->host, nrkreason);
+      
+      return 0;
+  }
+  
   current_date = smalldate((time_t) 0);
 
   ircsprintf(buffer, "%s (%s)",reason,current_date);
@@ -1256,17 +1276,50 @@
 
   aconf->ip = ip_host;
   aconf->ip_mask = ip_mask;
+  
+  if(temp_dline_time)
+  {
+      ircsprintf(buffer, "Temporary D-line %d min - %s (%s)",
+		 temp_dline_time, reason, current_date);
 
-  add_Dline(aconf);
+      aconf->hold = CurrentTime + temporary_dline_time_seconds;
 
-  sendto_realops("%s added D-Line for [%s] [%s]",
-		 sptr->name,
-		 host,
-		 reason);
+      add_temp_dline(aconf);
+      rehashed = YES;
+      dline_in_progress = YES;
 
-  log(L_TRACE, "%s added D-Line for [%s] [%s|%s]", 
-      sptr->name, host, reason,
-      oper_reason ? oper_reason : "" );
+      nextping = CurrentTime;
+
+      if (oper_reason != NULL)
+        sendto_realops("%s added temporary %d min. D-Line for [%s] [%s|%s]",
+                       parv[0], temp_dline_time, host, reason, oper_reason);
+      else
+        sendto_realops("%s added temporary %d min. D-Line for [%s] [%s]",
+                       parv[0], temp_dline_time, host, reason);
+
+      return 0;
+  }
+
+  add_Dline(aconf);
+
+  if (oper_reason != NULL)
+  {
+    sendto_realops("%s added D-Line for [%s] [%s|%s]",
+		   sptr->name,
+		   host,
+		   reason, oper_reason);
+    log(L_TRACE, "%s added D-Line for [%s] [%s|%s]",
+        sptr->name, host, reason, oper_reason);
+  }
+  else
+  {
+    sendto_realops("%s added D-Line for [%s] [%s]",
+                   sptr->name,
+                   host,
+                   reason);
+    log(L_TRACE, "%s added D-Line for [%s] [%s]",
+        sptr->name, host, reason);
+  }
 
   dconf = get_conf_name(DLINE_TYPE);
 
@@ -1287,12 +1340,13 @@
        */
       pptr->type = DLINE_TYPE;
       pptr->sptr = sptr;
-      pptr->rcptr = NULL;
       pptr->user = NULL;
       pptr->host = strdup(host);
       pptr->reason = strdup(reason);
       if (oper_reason != NULL)
 	pptr->oper_reason = strdup(oper_reason);
+      else
+        pptr->oper_reason = NULL;
       pptr->when = strdup(current_date);
 
       sendto_one(sptr,
@@ -1335,3 +1389,193 @@
   nextping = CurrentTime;
   return 0;
 } /* m_dline() */
+
+#ifdef XLINE_COMMAND
+
+/* XLINE addition patch - Not guaranteed!
+ * -Hwy
+ */
+
+int
+m_xline(aClient *cptr, aClient *sptr, int parc, char *parv[])
+
+{
+  char *host, *reason;
+  aClient *acptr;
+  aConfItem *aconf;
+  char buffer[1024];
+  const char* current_date;
+  const char *dconf;
+
+  if (!MyClient(sptr) || !IsAnOper(sptr))
+    {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      return 0;
+    }
+
+  if(!IsSetOperK(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
+      return 0;
+    }
+
+  if ( parc < 2 )
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "XLINE");
+      return 0;
+    }
+
+  host = parv[1];
+
+  if (parc > 2) /* host :reason */
+    {
+      if(strchr(parv[2], ':'))
+        {
+          sendto_one(sptr,
+                     ":%s NOTICE %s :Invalid character ':' in comment",
+                     me.name, parv[0]);
+          return 0;
+        }
+
+      if(strchr(parv[2], '#'))
+        {
+          sendto_one(sptr,
+                     ":%s NOTICE %s :Invalid character '#' in comment",
+                     me.name, parv[0]);
+          return 0;
+        }
+
+      if(*parv[2])
+        reason = parv[2];
+      else
+        reason = "No reason";
+    }
+  else
+    reason = "No reason";
+
+  current_date = smalldate((time_t) 0);
+
+  ircsprintf(buffer, "%s (%s)",reason,current_date);
+
+  aconf = make_conf();
+  aconf->status = CONF_XLINE;
+  aconf->user = NULL;
+  DupString(aconf->host,host);
+  DupString(aconf->name,host);
+  DupString(aconf->passwd,buffer);
+  aconf->port = GlobalSetOptions.xlinetype;
+  aconf->next = x_conf;
+  x_conf = aconf;
+
+        sendto_realops("%s added X-Line for [%s] [%s] [%d]",
+                sptr->name,
+                host,
+                reason, aconf->port);
+
+        log(L_TRACE, "%s added X-Line for [%s] [%s] [%d]",
+            sptr->name, host, reason, aconf->port);
+
+        dconf = get_conf_name(XLINE_TYPE);
+
+        /*
+         * Check if the conf file is locked - if so, add the dline
+         * to our pending dline list, to be written later, if not,
+         * allow this xline to be written, and write out all other
+         * pending lines as well
+         */
+        if (LockedFile(dconf))
+        {
+                aPendingLine *pptr;
+
+                pptr = AddPending();
+
+                /*
+                 * Now fill in the fields
+                 */
+                pptr->type = XLINE_TYPE;
+                pptr->sptr = sptr;
+                pptr->user = (char *) NULL;
+                pptr->host = strdup(host);
+                pptr->reason = strdup(reason);
+                pptr->when = strdup(current_date);
+
+                sendto_one(sptr,
+                        ":%s NOTICE %s :Added X-Line [%s] (config file write delayed)",
+                        me.name,
+                        sptr->name,
+                        host);
+
+                return 0;
+        }
+        else if (PendingLines)
+                WritePendingLines(dconf);
+
+        sendto_one(sptr,
+                ":%s NOTICE %s :Added X-Line [%s] to %s",
+                me.name,
+                sptr->name,
+                host,
+                dconf ? dconf : "configuration file");
+        /*
+         * Write xline to configuration file
+         */
+        WriteXline(dconf,
+                sptr,
+                host,
+                reason,
+                current_date);
+
+  return 0;
+} /* m_xline() */
+
+/*
+WriteXline()
+ Write out an xline to the kline configuration file
+*/
+
+static void
+WriteXline(const char *filename, aClient *sptr,
+           const char *host, const char *reason, const char *when)
+
+{
+  char buffer[1024];
+  int out;
+
+  if (!filename)
+    return;
+
+  if ((out = open(filename, O_RDWR|O_APPEND|O_CREAT, 0644)) == (-1))
+  {
+    sendto_realops("Error opening %s: %s",
+      filename,
+      strerror(errno));
+    return;
+  }
+
+  fchmod(out, 0660);
+
+  ircsprintf(buffer,
+    "#%s!%s@%s X'd: %s:%s (%s)\n",
+    sptr->name,
+    sptr->username,
+    sptr->host,
+    host,
+    reason,
+    when);
+
+  if (safe_write(sptr, filename, out, buffer) == (-1))
+    return;
+
+  ircsprintf(buffer, "X:%s:%s (%s)::%d\n",
+    host,
+    reason,
+    when, GlobalSetOptions.xlinetype);
+
+  if (safe_write(sptr, filename, out, buffer) == (-1))
+    return;
+
+  (void) close(out);
+} /* WriteXline() */
+
+#endif
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_locops.c ircd-hybrid-6.3.1/src/m_locops.c
--- ircd-hybrid-6.3.1.dist/src/m_locops.c	Mon Aug  9 22:46:24 1999
+++ ircd-hybrid-6.3.1/src/m_locops.c	Mon Apr 21 11:51:22 2003
@@ -98,57 +98,10 @@
 int m_locops(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 {
   char *message = NULL;
-#ifdef SLAVE_SERVERS
-  char *slave_oper;
-  struct Client *acptr;
-#endif
 
-#ifdef SLAVE_SERVERS
-  if(IsServer(sptr))
-    {
-      if(!find_special_conf(sptr->name,CONF_ULINE))
-        {
-          sendto_realops("received Unauthorized locops from %s",sptr->name);
-          return 0;
-        }
-
-      if(parc > 2)
-        {
-          slave_oper = parv[1];
-
-          parc--;
-          parv++;
-
-          if ((acptr = hash_find_client(slave_oper,(struct Client *)NULL)))
-            {
-              if(!IsPerson(acptr))
-                return 0;
-            }
-          else
-            return 0;
-
-          if(parv[1])
-            {
-              message = parv[1];
-              send_operwall(acptr, "SLOCOPS", message);
-            }
-          else
-            return 0;
-#ifdef HUB
-          sendto_slaves(sptr,"LOCOPS",slave_oper,parc,parv);
-#endif
-          return 0;
-        }
-    }
-  else
-    {
-      message = parc > 1 ? parv[1] : NULL;
-    }
-#else
   if(IsServer(sptr))
     return 0;
   message = parc > 1 ? parv[1] : NULL;
-#endif
 
   if (EmptyString(message))
     {
@@ -159,11 +112,7 @@
 
   if(MyConnect(sptr) && IsAnOper(sptr))
     {
-
-#ifdef SLAVE_SERVERS
-      sendto_slaves(NULL,"LOCOPS",sptr->name,parc,parv);
-#endif
-      send_operwall(sptr, "LOCOPS", message);
+      send_operwall(sptr, "LOCOPS", message, 1);
     }
   else
     {
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_ltrace.c ircd-hybrid-6.3.1/src/m_ltrace.c
--- ircd-hybrid-6.3.1.dist/src/m_ltrace.c	Sat Dec  8 00:10:22 2001
+++ ircd-hybrid-6.3.1/src/m_ltrace.c	Sat Apr 19 21:06:45 2003
@@ -153,8 +153,7 @@
     }
 
 
-  if(MyClient(sptr))
-    sendto_realops_flags(FLAGS_SPY, "ltrace requested by %s (%s@%s) [%s]",
+  sendto_realops_flags(FLAGS_SPY, "ltrace requested by %s (%s@%s) [%s]",
                        sptr->name, sptr->username, sptr->host,
                        sptr->user->server);
 
@@ -189,7 +188,16 @@
           sendto_one(sptr, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], c_class,
                      name,
-                     IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"255.255.255.255":ip),
+#if (defined SERVERHIDE) || (defined HIDE_SERVERS_IPS)
+                     "255.255.255.255",
+#else
+#ifdef HIDE_SPOOF_IPS
+                             IsIPSpoof(acptr) ? "255.255.255.255" : ip,
+#else
+                             IsAnOper(sptr) ? ip :
+                             (IsIPSpoof(acptr) ? "255.255.255.255" : ip),
+#endif
+#endif
                      now - acptr->lasttime,
                      (acptr->user)?(now - acptr->user->last):0);
         }
@@ -271,7 +279,16 @@
                            form_str(RPL_TRACEOPERATOR),
                            me.name, parv[0], c_class,
                            name, 
-                           IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"255.255.255.255":ip), 
+#if (defined SERVERHIDE) || (defined HIDE_SERVERS_IPS)
+                     "255.255.255.255",
+#else
+#ifdef HIDE_SPOOF_IPS
+                             IsIPSpoof(acptr) ? "255.255.255.255" : ip,
+#else
+                             IsAnOper(sptr) ? ip :
+                             (IsIPSpoof(acptr) ? "255.255.255.255" : ip),
+#endif
+#endif
                            now - acptr->lasttime,
                            (acptr->user)?(now - acptr->user->last):0);
               cnt++;
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_map.c ircd-hybrid-6.3.1/src/m_map.c
--- ircd-hybrid-6.3.1.dist/src/m_map.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/src/m_map.c	Sat May  3 10:19:22 2003
@@ -0,0 +1,124 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, contrib/m_map.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id$
+ */
+
+#include <assert.h>
+#include "ircd.h"
+#include "config.h"
+#include "client.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+#include "m_commands.h"
+#include <string.h>
+#include <stdio.h>
+
+#define USER_COL       50 /* display | Users: %d at col 50 */
+
+static char buf[BUFSIZE];
+
+static void dump_map(struct Client *cptr,struct Client *root_p, char *pbuf);
+
+/* m_map
+**     parv[0] = sender prefix
+*/
+
+int m_map(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
+{
+#ifdef SERVERHIDE
+  if (!IsAnOper(cptr))
+  {
+    sendto_one(cptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+    return;
+  }
+#endif
+  dump_map(cptr,&me,buf);
+  sendto_one(cptr, form_str(RPL_MAPEND), me.name, cptr->name);
+  sendto_realops_flags(FLAGS_SPY, "MAP requested by %s (%s@%s)",
+                       sptr->name, sptr->username, sptr->host);
+  return 0;
+}
+
+/*
+** dump_map
+**   dumps server map, called recursively.
+*/
+static void dump_map(struct Client *cptr,struct Client *root_p, char *pbuf)
+{
+  int cnt = 0, i = 0, len;
+  struct Client *server_p;
+
+  *pbuf= '\0';
+
+  strncat(pbuf,root_p->name,BUFSIZE - ((size_t) pbuf - (size_t) buf));
+  len = strlen(buf);
+  buf[len] = ' ';
+
+  if (len < USER_COL)
+  {
+     for (i = len+1; i < USER_COL; i++)
+     {
+       buf[i] = '-';
+     }
+  }
+
+  snprintf(buf + USER_COL, BUFSIZE - USER_COL,
+           " | Users: %5d (%4.1f%%)", root_p->serv->usercnt,
+           100 * (float) root_p->serv->usercnt / (float) Count.total);
+
+  sendto_one(cptr, form_str(RPL_MAP),me.name,cptr->name,buf);
+
+  if ((server_p = root_p->serv->servers))
+  {
+    for (; server_p; server_p = server_p->lnext)
+    {
+      cnt++;
+    }
+
+    if (cnt)
+    {
+      if (pbuf > buf + 3)
+      {
+        pbuf[-2] = ' ';
+        if (pbuf[-3] == '`')
+          pbuf[-3] = ' ';  
+      }
+    }
+  }
+  for (i = 1,server_p = root_p->serv->servers; server_p; server_p=server_p->lnext)
+  {
+    *pbuf = ' ';
+    if (i < cnt)
+      *(pbuf + 1) = '|';
+    else
+      *(pbuf + 1) = '`';
+
+    *(pbuf + 2) = '-';
+    *(pbuf + 3) = ' ';
+    dump_map(cptr,server_p,pbuf+4);
+
+    i++;
+   }
+}
+
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_message.c ircd-hybrid-6.3.1/src/m_message.c
--- ircd-hybrid-6.3.1.dist/src/m_message.c	Sat Dec 22 19:06:14 2001
+++ ircd-hybrid-6.3.1/src/m_message.c	Sat Apr 19 21:06:45 2003
@@ -554,3 +554,31 @@
 {
   return m_message(cptr, sptr, parc, parv, 1);
 }
+
+#ifdef WALLCHOPS
+/*
+** m_wallchops
+**      parv[0] = sender prefix
+**      parv[1] = receiver list
+**      parv[2] = notice text
+*/   
+      
+int     m_wallchops(struct Client *cptr,
+                 struct Client *sptr,
+                 int parc,
+                 char *parv[])
+{
+  char buf[CHANNELLEN + 2];
+
+  if (parc > 1)
+  {
+    ircsprintf(buf, "@%s", parv[1]);
+    parv[1] = buf;
+  }
+  /* If the parc is less than or equal to 1, let m_message take care of
+   * reporting it to the user
+   */
+  return m_message(cptr, sptr, parc, parv, 1);
+}
+#endif
+
